function scene_raymarching()
{
	this.load = function(fragment_shader)
	{
		this.composer = new THREE.EffectComposer(renderer);

		this.rayMarchingPass = new THREE.RayMarchingPass(fragment_shader);
		this.composer.addPass(this.rayMarchingPass);
		
		this.badTVShader = new THREE.ShaderPass(THREE.BadTVShader);
		this.composer.addPass(this.badTVShader);

		this.fxaaPass = new THREE.ShaderPass(THREE.FXAAShader);
		this.fxaaPass.uniforms[ 'resolution' ].value = new THREE.Vector2( 1 / wWidth, 1 / wHeight );
		this.composer.addPass(this.fxaaPass);
		
		this.composer.addPass(final_pass);
	}

	this.render = function(scene_time, percent)
	{
		this.badTVShader.uniforms["distortion"].value = getVal("var1");
		this.badTVShader.uniforms["distortion2"].value = getVal("var2");
		this.badTVShader.uniforms["speed"].value = getVal("var3");
		this.badTVShader.uniforms["rollSpeed"].value = getVal("var4");

		this.badTVShader.uniforms["time"].value = getVal("percent");
		this.rayMarchingPass.setVar("var1", getVal("var1"));
		this.rayMarchingPass.setVar("var2", getVal("var2"));
		this.rayMarchingPass.setVar("var3", getVal("var3"));
		this.rayMarchingPass.setVar("var4", getVal("var4"));
		this.rayMarchingPass.setVar("var5", getVal("var5"));
		this.rayMarchingPass.setVar("var6", getVal("var6"));
		this.rayMarchingPass.setVar("var7", getVal("var7"));

		//this.badTVShader.uniforms["time"].value = scene_time;
		final_pass.uniforms["rgbShift"].value = 0.0;
		this.composer.render();
	}
}